diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
index 62cdf9781..19e2afc00 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
@@ -1,7 +1,9 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.entity.EntityItem;
 import org.jetbrains.annotations.NotNull;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
@@ -17,19 +19,26 @@ public class EntityRendererItem extends EntityRenderer<EntityItem> {
         this.shadowOpacity = 0.75F;
     }
 
+    static float getDespawnFadeAlpha(final @NotNull EntityItem entity, final float partialTick) {
+        return EntityItem.getDespawnFadeAlpha(entity.age, entity.lifetime, partialTick);
+    }
+
     public void render(@NotNull TessellatorGeneral tessellator, final @NotNull EntityItem entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
-        int prime = ((entity.lifetime * 3)/4);
-        if (entity.lifetime >= 0 && (entity.age + partialTick) > prime) {
-            int pastPrime = entity.age - prime;
-            double toDeath = 1 - ((pastPrime + partialTick) * 4d)/entity.lifetime; // progress of age from 75% of lifetime to 100%
-            if (Math.cos(((pastPrime + partialTick) * Math.PI)/ (2.5 + 5.5 * toDeath)) > 0) return;
-        }
         final ItemStack itemstack = entity.item;
         if (itemstack == null) {
             return;
         }
+        final float fadeAlpha = getDespawnFadeAlpha(entity, partialTick);
+        if (entity.age >= entity.lifetime && entity.lifetime >= 0 && fadeAlpha <= EntityItem.DESPAWN_ALPHA_THRESHOLD) {
+            return;
+        }
         Item item = itemstack.getItem();
         GLRenderer.pushFrame();
+        if (fadeAlpha < 1.0f) {
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, fadeAlpha);
+        }
         final float bobbingOffset = MathHelper.sin((entity.age + partialTick) / 10F + entity.bobOffset) * 0.1F + 0.1F;
         final float yw = (float) Math.toDegrees(((entity.age + partialTick) / 20F + entity.bobOffset));
         byte renderCount = 1;
@@ -44,6 +53,18 @@ public class EntityRendererItem extends EntityRenderer<EntityItem> {
         }
         GLRenderer.modelM4f().translate((float) x, (float) (y + bobbingOffset), (float) z);
         ItemModelDispatcher.getInstance().getDispatch(item).renderItemEntity(tessellator, itemstack, GameSettings.ITEMS_3D.value, renderCount, entity.age, yw, entity.getLightIndex(partialTick), partialTick);
+        if (fadeAlpha < 1.0f) {
+            GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+        }
         GLRenderer.popFrame();
     }
+
+    @Override
+    public void postRender(@NotNull TessellatorGeneral tessellator, @NotNull EntityItem entity, double x, double y, double z, float yaw, float partialTick) {
+        final float fadeAlpha = getDespawnFadeAlpha(entity, partialTick);
+        final float savedShadowOpacity = this.shadowOpacity;
+        this.shadowOpacity *= fadeAlpha;
+        super.postRender(tessellator, entity, x, y, z, yaw, partialTick);
+        this.shadowOpacity = savedShadowOpacity;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 957ee5aad..3393df3ae 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -46,12 +46,21 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
 
         this.setupModels.clear();
         final int maxRenderLayer = maxRenderLayer(entity);
+        final float renderAlpha = getRenderAlpha(entity, partialTick);
+        final boolean translucent = renderAlpha < 1.0f;
+        //should fix water/particles rendering through pigu :3
+        if (translucent) {
+            GLRenderer.setDepthMask(false);
+        }
         for (int layer = 0; layer <= maxRenderLayer; layer++) {
             try {
                 GLRenderer.pushFrame();
                 final StaticEntityModel model = getAndSetupModelForLayer(entity, 1f, partialTick, layer);
                 this.setupModels.add(model);
                 if (model != null) {
+                    if (translucent) {
+                        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, renderAlpha);
+                    }
                     model.render();
                 }
                 GLRenderer.popFrame();
@@ -59,6 +68,10 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
                 LOGGER.error("Error setting up model on layer '{}' in renderer '{}'", layer, getClass().getSimpleName(), e);
             }
         }
+        if (translucent) {
+            GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+            GLRenderer.setDepthMask(true);
+        }
         renderAdditional(tessellator, entity, partialTick);
 
         final int argb = getOverlayColor(entity, partialTick);
@@ -133,6 +146,10 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
         return baseSize;
     }
 
+    protected float getRenderAlpha(final @NotNull T entity, final float partialTick) {
+        return 1.0f;
+    }
+
     protected float getLimbSwing(final @NotNull T entity, final float partialTick) {
         return entity.walkAnimPos - entity.walkAnimSpeed * (1.0F - partialTick);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPig.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPig.java
index 5c85103b8..512c0b7c6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPig.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPig.java
@@ -1,20 +1,102 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.animal.MobPig;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 public class MobRendererPig extends MobRendererQuadruped<MobPig> {
 
+    @Override
+    protected void renderSpecials(@NotNull final TessellatorGeneral tessellator, @NotNull final MobPig entity, final double x, final double y, final double z) {
+        if (entity.passenger != null) {
+            return;
+        }
+        super.renderSpecials(tessellator, entity, x, y, z);
+    }
+
     public MobRendererPig(final float shadowSize) {
         super(shadowSize);
     }
 
+    private static final float LOOK_FADE_TARGET = 0.2f;
+    private static final float LOOK_FADE_RATE = 16.0f;
+
+    @Override
+    protected float getRenderAlpha(@NotNull final MobPig entity, final float partialTick) {
+        final long now = System.nanoTime();
+        float dt = entity.lookFadeLastRenderNanos == 0L ? 0f : (now - entity.lookFadeLastRenderNanos) / 1_000_000_000f;
+        entity.lookFadeLastRenderNanos = now;
+        dt = MathHelper.clamp(dt, 0f, 0.1f);
+
+        if (!isRiderLookingAtOwnPig(entity, partialTick)) {
+            entity.lookFadeAlpha = 1.0f;
+            return 1.0f;
+        }
+
+        final float t = 1.0f - (float) Math.exp(-LOOK_FADE_RATE * dt);
+        entity.lookFadeAlpha += (LOOK_FADE_TARGET - entity.lookFadeAlpha) * t;
+        if (Math.abs(entity.lookFadeAlpha - LOOK_FADE_TARGET) < 0.01f) {
+            entity.lookFadeAlpha = LOOK_FADE_TARGET;
+        }
+        return entity.lookFadeAlpha;
+    }
+
+    @Override
+    public float getShadowSize(@NotNull final MobPig entity) {
+        if (entity.lookFadeAlpha < 0.9f) {
+            return 0.0f;
+        }
+        return super.getShadowSize(entity);
+    }
+
+    private boolean isRiderLookingAtOwnPig(@NotNull final MobPig entity, final float partialTick) {
+        if (GameSettings.THIRD_PERSON_VIEW.value != 0) {
+            return false;
+        }
+
+        final Minecraft mc = Minecraft.getMinecraft();
+        final Player player = mc.thePlayer;
+        if (player == null || entity != player.vehicle) {
+            return false;
+        }
+
+        final ItemStack held = player.inventory.getCurrentItem();
+        if (held != null && (held.itemID == Blocks.MUSHROOM_BROWN.id() || held.itemID == Blocks.MUSHROOM_RED.id())) {
+            return false;
+        }
+
+        final Vector3dc eye = player.getPosition(partialTick, true);
+        final Vector3dc look = player.getViewVector(partialTick);
+        if (look == null) {
+            return false;
+        }
+
+        final double reach = player.getGamemode().getEntityReachDistance() + 1.0;
+        final Vector3d end = new Vector3d(look).mul(reach).add(eye);
+
+        final double offX = (entity.xo - entity.x) * (1.0 - partialTick);
+        final double offY = (entity.yo - entity.y) * (1.0 - partialTick);
+        final double offZ = (entity.zo - entity.z) * (1.0 - partialTick);
+
+        final AABBd renderedBox = entity.bb.translate(offX, offY, offZ, new AABBd());
+        return MathHelper.aabbClip(renderedBox, eye, end) != null;
+    }
+
     @Override
     protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobPig entity, final float brightness, final float partialTick, final int layer) {
+        final boolean sitting = entity.getSitting();
         final StaticEntityModel model;
         if (layer == 1) {
             bindTexture("/assets/minecraft/textures/entity/saddle.png");
@@ -25,23 +107,51 @@ public class MobRendererPig extends MobRendererQuadruped<MobPig> {
         model.resetBones();
 
         final BoneTransform head = model.getTransform("head");
-        final BoneTransform leg0 = model.getTransform("leg0");
-        final BoneTransform leg1 = model.getTransform("leg1");
-        final BoneTransform leg2 = model.getTransform("leg2");
-        final BoneTransform leg3 = model.getTransform("leg3");
-
         final float bodyYaw = getBodyYaw(entity, partialTick);
         final float headYaw = getHeadYaw(entity, partialTick) - bodyYaw;
         final float headPitch = getHeadPitch(entity, partialTick);
-        final float limbSwing = getLimbSwing(entity, partialTick);
-        final float limbYaw = getLimbYaw(entity, partialTick);
-
-        head.rotX = headPitch;
-        head.rotY = headYaw;
-        leg0.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
-        leg1.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
-        leg2.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
-        leg3.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+
+        if (sitting) {
+            final BoneTransform body = model.getTransform("body");
+            final BoneTransform leg0 = model.getTransform("leg0");
+            final BoneTransform leg1 = model.getTransform("leg1");
+
+            body.rotX = -27.5 * MathHelper.DEG_TO_RAD;
+            body.posY = -4;
+            body.posZ = 1;
+
+            leg0.rotX = -90 * MathHelper.DEG_TO_RAD;
+            leg0.rotY = 15 * MathHelper.DEG_TO_RAD;
+            leg0.posX = -1;
+            leg0.posY = -4;
+
+            leg1.rotX = -90 * MathHelper.DEG_TO_RAD;
+            leg1.rotY = -15 * MathHelper.DEG_TO_RAD;
+            leg1.posX = 1;
+            leg1.posY = -4;
+
+            head.posZ = 1;
+            head.rotX += headPitch;
+            head.rotY += headYaw;
+
+        } else {
+
+            head.rotX = headPitch;
+            head.rotY = headYaw;
+
+            final BoneTransform leg0 = model.getTransform("leg0");
+            final BoneTransform leg1 = model.getTransform("leg1");
+            final BoneTransform leg2 = model.getTransform("leg2");
+            final BoneTransform leg3 = model.getTransform("leg3");
+            final float limbSwing = getLimbSwing(entity, partialTick);
+            final float limbYaw = getLimbYaw(entity, partialTick);
+
+            leg0.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+            leg1.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+            leg2.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+            leg3.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+
+        }
 
         return model;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index be6db2908..6ed6552e2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -40,6 +40,14 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
         super(0.5F);
     }
 
+    @Override
+    public float getShadowSize(final @NotNull Player entity) {
+        if (entity.vehicle != null) {
+            return 0.0f;
+        }
+        return super.getShadowSize(entity);
+    }
+
     protected @NotNull StaticEntityModel getActiveModel(final @NotNull Player player, final boolean onlyArms) {
         var overrideModel = EntityGeometryMojangData.Cache.getPlayerModelOverride(player.uuid,
             onlyArms ? EntityGeometryMojangData.PlayerModelOverrideComponent.ARMS : EntityGeometryMojangData.PlayerModelOverrideComponent.MAIN);
@@ -226,9 +234,20 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
                 GLRenderer.modelM4f().translate(0.0F, 0.0F, 0.125F);
                 final float yawOff = player.yBodyRotO + (player.yBodyRot - player.yBodyRotO) * partialTick;
                 final float bodyAngle = 5;
-                final double xd = MathHelper.lerp(player.xdO, player.xd, partialTick);
-                final double yd = Math.min(MathHelper.lerp(player.ydO, player.yd, partialTick), 0);
-                final double zd = MathHelper.lerp(player.zdO, player.zd, partialTick);
+
+                final double xd;
+                final double yd;
+                final double zd;
+                if (player.vehicle != null) {
+                    xd = player.x - player.xo;
+                    yd = Math.min(player.y - player.yo, 0);
+                    zd = player.z - player.zo;
+                } else {
+                    xd = MathHelper.lerp(player.xdO, player.xd, partialTick);
+                    yd = Math.min(MathHelper.lerp(player.ydO, player.yd, partialTick), 0);
+                    zd = MathHelper.lerp(player.zdO, player.zd, partialTick);
+                }
+
                 final double vel = -1 / (3 * Math.hypot(xd, zd) + 1) + 1;
                 final double moveAng = Math.atan2(xd, zd);
                 final double yawRad = Math.toRadians(yawOff);
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
index 4410a5f79..870318f16 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.particle;
 import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.LightIndexHelper;
@@ -21,7 +22,7 @@ import java.util.concurrent.ThreadLocalRandom;
  */
 public class Particle {
     protected static final Random random = new Random();
-    public IconCoordinate tex;
+    public @Nullable IconCoordinate tex;
     protected float uo;
     protected float vo;
     protected int age;
@@ -51,8 +52,6 @@ public class Particle {
     public boolean onGround = false;
     public boolean removed = false;
 
-    private final TilePos qPos = new TilePos();
-
     public @NotNull World world;
 
     /**
@@ -88,33 +87,6 @@ public class Particle {
         this.age = 0;
     }
 
-    public Particle resetBase(@NotNull World world, double x, double y, double z, double xa, double ya, double za) {
-        this.world = world;
-        this.x = x;
-        this.y = y;
-        this.z = z;
-        this.rCol = this.gCol = this.bCol = 1.0F;
-        ThreadLocalRandom tlr = ThreadLocalRandom.current();
-        this.xd = xa + (float) (tlr.nextDouble() * 2D - 1.0D) * 0.4F;
-        this.yd = ya + (float) (tlr.nextDouble() * 2D - 1.0D) * 0.4F;
-        this.zd = za + (float) (tlr.nextDouble() * 2D - 1.0D) * 0.4F;
-        float speed = (float) (tlr.nextDouble() + tlr.nextDouble() + 1.0D) * 0.15F;
-        float dd = MathHelper.sqrt(this.xd * this.xd + this.yd * this.yd + this.zd * this.zd);
-        this.xd = (this.xd / dd) * speed * 0.4D;
-        this.yd = (this.yd / dd) * speed * 0.4D + 0.1D;
-        this.zd = (this.zd / dd) * speed * 0.4D;
-        this.uo = random.nextFloat() * 3F;
-        this.vo = random.nextFloat() * 3F;
-        this.size = (random.nextFloat() * 0.5F + 0.5F) * 2.0F;
-        this.lifetime = (int) (4F / (random.nextFloat() * 0.9F + 0.1F));
-        this.age = 0;
-
-        this.removed = false;
-        this.noPhysics = false;
-        this.onGround = false;
-        return this;
-    }
-
     public void init() {
         this.xo = this.x;
         this.yo = this.y;
@@ -174,6 +146,7 @@ public class Particle {
     }
 
     public void move(double dx, double dy, double dz) {
+        class Cache { private static final @NotNull TilePos queryPos = new TilePos(); }
         if (this.noPhysics) {
             this.x += dx;
             this.y += dy;
@@ -185,8 +158,8 @@ public class Particle {
 
         // Y-Axis
         if (dy != 0) {
-            this.qPos.set(MathHelper.floor(this.x), MathHelper.floor(this.y + dy), MathHelper.floor(this.z));
-            AABBdc bb = getCollisionBox(this.qPos);
+            Cache.queryPos.set(MathHelper.floor(this.x), MathHelper.floor(this.y + dy), MathHelper.floor(this.z));
+            AABBdc bb = getCollisionBox(Cache.queryPos);
 
             boolean collided = false;
             if (bb != null && this.x >= bb.minX() && this.x <= bb.maxX() && this.z >= bb.minZ() && this.z <= bb.maxZ()) {
@@ -213,8 +186,8 @@ public class Particle {
 
         // X-Axis
         if (dx != 0) {
-            this.qPos.set(MathHelper.floor(this.x + dx), MathHelper.floor(this.y), MathHelper.floor(this.z));
-            AABBdc bb = getCollisionBox(this.qPos);
+            Cache.queryPos.set(MathHelper.floor(this.x + dx), MathHelper.floor(this.y), MathHelper.floor(this.z));
+            AABBdc bb = getCollisionBox(Cache.queryPos);
 
             boolean collided = false;
             if (bb != null && this.y >= bb.minY() && this.y <= bb.maxY() && this.z >= bb.minZ() && this.z <= bb.maxZ()) {
@@ -236,8 +209,8 @@ public class Particle {
 
         // Z-Axis
         if (dz != 0) {
-            this.qPos.set(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z + dz));
-            AABBdc bb = getCollisionBox(this.qPos);
+            Cache.queryPos.set(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z + dz));
+            AABBdc bb = getCollisionBox(Cache.queryPos);
 
             boolean collided = false;
             if (bb != null && this.x >= bb.minX() && this.x <= bb.maxX() && this.y >= bb.minY() && this.y <= bb.maxY()) {
@@ -302,18 +275,19 @@ public class Particle {
     }
 
     public float calcBrightness(float pt) {
+        class Cache { private static final @NotNull TilePos queryPos = new TilePos(); }
         if (Global.accessor.isFullbrightEnabled()) {
             return 1.0f;
         }
 
-        this.qPos.set(
+        Cache.queryPos.set(
             MathHelper.floor(MathHelper.lerp(this.xo, this.x, pt)),
             MathHelper.floor(MathHelper.lerp(this.yo, this.y, pt)),
             MathHelper.floor(MathHelper.lerp(this.zo, this.z, pt))
         );
 
-        if (this.world.areBlocksLoaded(this.qPos, this.qPos)) {
-            return this.world.getLightBrightness(this.qPos);
+        if (this.world.areBlocksLoaded(Cache.queryPos, Cache.queryPos)) {
+            return this.world.getLightBrightness(Cache.queryPos);
         }
         return 0;
     }
@@ -323,23 +297,24 @@ public class Particle {
     }
 
     public byte calcLightIndex(float pt) {
+        class Cache { private static final @NotNull TilePos queryPos = new TilePos(); }
         if (Global.accessor.isFullbrightEnabled()) return LightIndexHelper.lightIndex2i(15, 15);
 
         int bX = MathHelper.floor(MathHelper.lerp(this.xo, this.x, pt));
         int bY = MathHelper.floor(MathHelper.lerp(this.yo, this.y, pt));
         int bZ = MathHelper.floor(MathHelper.lerp(this.zo, this.z, pt));
 
-        if (this.world.getBlockLitInteriorSurface(this.qPos.set(bX, bY, bZ))) {
+        if (this.world.getBlockLitInteriorSurface(Cache.queryPos.set(bX, bY, bZ))) {
             byte lIdx = 0;
-            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(this.qPos.set(bX, bY + 1, bZ)));
-            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(this.qPos.set(bX - 1, bY, bZ)));
-            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(this.qPos.set(bX + 1, bY, bZ)));
-            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(this.qPos.set(bX, bY, bZ + 1)));
-            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(this.qPos.set(bX, bY, bZ - 1)));
+            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(Cache.queryPos.set(bX, bY + 1, bZ)));
+            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(Cache.queryPos.set(bX - 1, bY, bZ)));
+            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(Cache.queryPos.set(bX + 1, bY, bZ)));
+            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(Cache.queryPos.set(bX, bY, bZ + 1)));
+            lIdx = LightIndexHelper.max(lIdx, this.world.getSavedLightIndex(Cache.queryPos.set(bX, bY, bZ - 1)));
             return lIdx;
         }
 
-        return this.world.getSavedLightIndex(this.qPos.set(bX, bY, bZ));
+        return this.world.getSavedLightIndex(Cache.queryPos.set(bX, bY, bZ));
     }
 
     public byte getLightIndex(float partialTick) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAcidBoiling.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAcidBoiling.java
index 131c3a8a2..bcce0bc5b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAcidBoiling.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAcidBoiling.java
@@ -1,20 +1,14 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
-import org.jetbrains.annotations.NotNull;
 
 public class ParticleAcidBoiling extends Particle {
-
 	private float sinTimer = 0.0F;
 	private final boolean isReversed;
 	private final boolean needsWater;
-	private final TilePos qpos = new TilePos();
-	private final @NotNull IconCoordinate popping = TextureRegistry.getTexture("minecraft:particle/acid_boiling_pop");
 
 	public ParticleAcidBoiling(World world, double x, double y, double z, double xa, double ya, double za, boolean needsWater) {
 		super(world, x, y, z, xa, ya, za);
@@ -22,7 +16,7 @@ public class ParticleAcidBoiling extends Particle {
 		this.rCol = 1.0F;
 		this.gCol = 1.0F;
 		this.bCol = 1.0F;
-		this.tex = TextureRegistry.getTexture("minecraft:particle/acid_boiling");
+		this.tex = ParticleTextureCache.ICON_ACID_BOILING;
 		this.size *= random.nextFloat() * 0.7F + 0.3F;
 		this.xd = xa * 0.2 + (Math.random() * (double) 2.0F - (double) 1.0F) * (double) 0.02F;
 		this.yd = ya * 0.2 + (Math.random() * (double) 2.0F - (double) 1.0F) * (double) 0.02F;
@@ -33,6 +27,9 @@ public class ParticleAcidBoiling extends Particle {
 
 	@Override
 	public void tick() {
+		class Cache {
+			private static final TilePos queryPos = new TilePos();
+		}
 		++this.sinTimer;
 		if (this.sinTimer > 100.0F) {
 			this.sinTimer = 0.0F;
@@ -43,7 +40,7 @@ public class ParticleAcidBoiling extends Particle {
 		this.yo = this.y;
 		this.zo = this.z;
 		double expand = 0.05;
-		boolean inWater = this.world.getBlockMaterial(this.qpos.set((int) this.x, (int) this.y, (int) this.z)) == Materials.ACID;
+		boolean inWater = this.world.getBlockMaterial(Cache.queryPos.set((int) this.x, (int) this.y, (int) this.z)) == Materials.ACID;
 		if (inWater) {
 			this.yd = 0.2;
 			this.xd = MathHelper.sin(this.sinTimer * 0.95F) / 30.0F * (float) (this.isReversed ? -1 : 1);
@@ -61,7 +58,7 @@ public class ParticleAcidBoiling extends Particle {
 		}
 
 		if (this.lifetime == 6) {
-			this.tex = this.popping;
+			this.tex = ParticleTextureCache.ICON_ACID_POPPING;
 			this.world.spawnParticle("arrowtrail", this.x, this.y, this.z, 0.0F, 0.0F, 0.0F, 1, false);
 		} else if (this.lifetime <= 0) {
 			this.remove();
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
index dc1c3086e..0896a5451 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.tessellator.TessellatorParticle;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
@@ -20,7 +19,7 @@ public class ParticleArrowGolden extends Particle {
         this.xd += xa;
         this.yd += ya;
         this.zd += za;
-        this.rCol = gCol = 0.8f;
+        this.rCol = this.gCol = 0.8f;
         this.bCol = (float) (Math.random() * 0.3D);
         this.size *= 0.75F;
         this.size *= scale;
@@ -52,12 +51,7 @@ public class ParticleArrowGolden extends Particle {
         if (this.age++ >= this.lifetime) {
             this.remove();
         }
-        int val = (7 - ((this.age * 8) / this.lifetime));
-        if (val >= 0) {
-            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
-        } else {
-            this.tex = null;
-        }
+        this.tex = ParticleTextureCache.getPuffStage(this.age, this.lifetime);
         this.yd += 0.004D;
         this.move(this.xd, this.yd, this.zd);
         if (this.y == this.yo) {
@@ -72,5 +66,4 @@ public class ParticleArrowGolden extends Particle {
             this.zd *= 0.7D;
         }
     }
-
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
index 2ae163ce5..0f080c642 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 
 public class ParticleAsh extends Particle {
@@ -12,6 +11,7 @@ public class ParticleAsh extends Particle {
         this.rCol = this.gCol = this.bCol = 0.2F + random.nextFloat() * 0.3F;
         this.size = random.nextFloat() * random.nextFloat() * 6F + 1.0F;
         this.lifetime = (int) (64 / (random.nextFloat() * 0.8D + 0.2D)) + 2;
+        this.tex = ParticleTextureCache.ICON_PUFF_STAGES[0];
     }
 
     @Override
@@ -23,7 +23,6 @@ public class ParticleAsh extends Particle {
         if (this.age++ >= this.lifetime) {
             this.remove();
         }
-        this.tex = TextureRegistry.getTexture("minecraft:particle/puff_0");
         move(this.xd, this.yd, this.zd);
         this.xd *= 0.9D;
         this.zd *= 0.9D;
